#!/usr/bin/perl

# 0 - input go.xml
# 1 - output go alternates file, 
# 2 - output go depth file
# 3 - output go tree file

%GOS = ();

open (FH, $ARGV [0]);
open (FH2, ">$ARGV[1]");
open (FH3, ">$ARGV[3]");

$id = "";
$is = "";

while (<FH>) {

 $aLine = $_;
 chomp ($aLine);

 # when meeting a term ender
 # end the line

 if ($aLine =~ /<\/term>/) {

  $GOS {$id} = $is;

  $id = "";
  $is = "";

 }

 # when meeting an ID
 # open a new line

 if ($aLine =~ /<id>([\w:]*)<\/id>/) {

  $id = $1;

 }

 # when meeting an isa
 # continue the line

 if ($aLine =~ /<is\_a>([\w:]*)<\/is\_a>/) {

  $is = $is." ".$1;

 }

 # when meeting an alt_id
 # continue the line

 if ($aLine =~ /<alt\_id>([\w:]*)<\/alt\_id>/) {

  print FH2 "$1 $id\n";

 }

 # when meeting a to
 # continue the line

 if ($aLine =~ /<to>([\w:]*)<\/to>/) {

  $is = $is." ".$1;

 }

}

close (FH);
close (FH2);

%fullGOS = ();

for $goTerm (keys % GOS) {

 $all = &harvest ($GOS {$goTerm});

 @allA = split (" ", $all);

 %allH = ();

 foreach $allS (@allA) {

  if (! exists ($allH {$allS})) {

   $allH {$allS} = "";

  }

 }

 $newString = "";

 foreach $allS (keys % allH) {

  $newString = $newString." ".$allS;

 }

 $fullGOS {$goTerm} = $newString;

}

foreach $goTerm (keys % fullGOS) {

 print FH3 "$goTerm";

 @terms = split (" ", $fullGOS {$goTerm});

 foreach $aTerm (@terms) {

  print FH3 " $aTerm";

 }

 print FH3 "\n";

}

open (FH, ">$ARGV[2]");

foreach $goTerm (keys % GOS) {

 $depth = &findDepth ($goTerm);

 print FH "$goTerm $depth\n";

}

close (FH);

sub findDepth {

 local ($anID, @isS, $isSs, $aDepth, $minDepth);

 $anID = $_[0];

 if ($GOS {$anID} eq "") {

  $minDepth = 0;
  $minDepth;  

 }

 else {

  @isS = split (" ", $GOS {$anID});

  $minDepth = 1000;

  foreach $isSs (@isS) {

   $aDepth = &findDepth ($isSs);

   if ($aDepth < $minDepth) {

    $minDepth = $aDepth;

   }

  }

  $minDepth++;

  $minDepth;

 }

}

close (FH3);

sub harvest {

 local ($isString, $resultString, $isSs, @isS, $bitterHarvest);

 $isString = $_[0];

 @isS = split (" ", $isString);

 $resultString = "";

 foreach $isSs (@isS) {

  $resultString = $resultString." ".$isSs;


  $bitterHarvest = &harvest ($GOS {$isSs});

  if (length ($bitterHarvest) > 0) {

   $resultString = $resultString." ".$bitterHarvest;

  }

 }

 $resultString;

}